package no.ntnu.idatt1002.demo.data;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

public class ItemOverviewTest {
    ItemOverview itemOverview;

    @BeforeEach
    public void createItemOverView(){
        itemOverview = new ItemOverview();
    }
    @Test
    @DisplayName("addItem method throws exception when it should")
    void addItemThrows(){
        Income income = new Income("description", 59.9f, false, IncomeCategory.SALARY, "03.03.23");
        assertThrows(IllegalArgumentException.class, () -> {itemOverview.addItem(income); itemOverview.addItem(income);});
    }

    @Test
    @DisplayName("addItem method does not throw exception when it should not")
    void addItemDoesNotThrow(){
        Expense expense = new Expense("description", 59.9f, false, ExpenseCategory.CLOTHES, "03.03.23");
        Income income = new Income("anotherDescription", 6.5f, true, IncomeCategory.SALARY, "02.03.23");
        assertDoesNotThrow(() -> {itemOverview.addItem(expense); itemOverview.addItem(income);});
    }

    @Test
    @DisplayName("getTotalSum method gives correct amount")
    void getTotalSumCorrectAmount(){
        itemOverview.addItem(new Income("description1", 59.9f, false, IncomeCategory.SALARY, "03.03.23"));
        itemOverview.addItem(new Income("description2", 62.4f, true, IncomeCategory.GIFT, "01.02.21"));
        itemOverview.addItem(new Income("description3", 9.81f, false, IncomeCategory.SALARY, "05.07.23"));
        double totalIncome = 59.9f + 62.4f + 9.81f;
        assertEquals(Math.round(itemOverview.getTotalSum()), Math.round(totalIncome));
    }
}